Package io.vertx.ext.shell.command

## Interface CommandProcess

- All Superinterfaces:
    `Tty`

      public interface CommandProcess
      extends Tty

  The command process provides interaction with the process of the command provided by Vert.x Shell.
  Author:
    Julien Viet

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `List<String>` | `args()` |
    `List<CliToken>` | `argsTokens()` |
    `CommandProcess` | `backgroundHandler​(Handler<Void> handler)` | Set a background handler, this handler is called when the command is running and put to background.
    `CommandLine` | `commandLine()` |
    `void` | `end()` | End the process with the exit status 0
    `void` | `end​(int status)` | End the process.
    `CommandProcess` | `endHandler​(Handler<Void> handler)` | Set an end handler, this handler is called when the command is ended, for instance the command is running and the shell closes.
    `CommandProcess` | `foregroundHandler​(Handler<Void> handler)` | Set a foreground handler, this handler is called when the command is running and put to foreground.
    `CommandProcess` | `interruptHandler​(Handler<Void> handler)` | Set an interrupt handler, this handler is called when the command is interrupted, for instance user press `Ctrl-C`.
    `boolean` | `isForeground()` |
    `CommandProcess` | `resizehandler​(Handler<Void> handler)` | Set a resize handler, the handler is called when the tty size changes.
    `CommandProcess` | `resumeHandler​(Handler<Void> handler)` | Set a resume handler, this handler is called when the command is resumed, for instance user types `bg` or `fg` to resume the command.
    `Session` | `session()` |
    `CommandProcess` | `stdinHandler​(Handler<String> handler)` | Set a stream handler on the standard input to read the data.
    `CommandProcess` | `suspendHandler​(Handler<Void> handler)` | Set a suspend handler, this handler is called when the command is suspended, for instance user press `Ctrl-Z`.
    `Vertx` | `vertx()` |
    `CommandProcess` | `write​(String data)` | Write some text to the standard output.

    - ### Methods inherited from interface io.vertx.ext.shell.term.Tty

      `height, type, width`

- - ### Method Detail

    - #### vertx

          Vertx vertx()

      Returns:
        the current Vert.x instance

    - #### argsTokens

          List<CliToken> argsTokens()

      Returns:
        the unparsed arguments tokens

    - #### args

          List<String> args()

      Returns:
        the actual string arguments of the command

    - #### commandLine

          CommandLine commandLine()

      Returns:
        the command line object or null

    - #### session

          Session session()

      Returns:
        the shell session

    - #### isForeground

          boolean isForeground()

      Returns:
        true if the command is running in foreground

    - #### stdinHandler

          CommandProcess stdinHandler​(Handler<String> handler)

      Description copied from interface: `Tty`
      Set a stream handler on the standard input to read the data.
      Specified by:
        `stdinHandler` in interface `Tty`
      Parameters:
        `handler` - the standard input
      Returns:
        this object

    - #### interruptHandler

          CommandProcess interruptHandler​(Handler<Void> handler)

      Set an interrupt handler, this handler is called when the command is interrupted, for instance user press `Ctrl-C`.
      Parameters:
        `handler` - the interrupt handler
      Returns:
        this command

    - #### suspendHandler

          CommandProcess suspendHandler​(Handler<Void> handler)

      Set a suspend handler, this handler is called when the command is suspended, for instance user press `Ctrl-Z`.
      Parameters:
        `handler` - the interrupt handler
      Returns:
        this command

    - #### resumeHandler

          CommandProcess resumeHandler​(Handler<Void> handler)

      Set a resume handler, this handler is called when the command is resumed, for instance user types `bg` or `fg` to resume the command.
      Parameters:
        `handler` - the interrupt handler
      Returns:
        this command

    - #### endHandler

          CommandProcess endHandler​(Handler<Void> handler)

      Set an end handler, this handler is called when the command is ended, for instance the command is running and the shell closes.
      Parameters:
        `handler` - the end handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### write

          CommandProcess write​(String data)

      Write some text to the standard output.
      Specified by:
        `write` in interface `Tty`
      Parameters:
        `data` - the text
      Returns:
        a reference to this, so the API can be used fluently

    - #### backgroundHandler

          CommandProcess backgroundHandler​(Handler<Void> handler)

      Set a background handler, this handler is called when the command is running and put to background.
      Parameters:
        `handler` - the background handler
      Returns:
        this command

    - #### foregroundHandler

          CommandProcess foregroundHandler​(Handler<Void> handler)

      Set a foreground handler, this handler is called when the command is running and put to foreground.
      Parameters:
        `handler` - the foreground handler
      Returns:
        this command

    - #### resizehandler

          CommandProcess resizehandler​(Handler<Void> handler)

      Description copied from interface: `Tty`
      Set a resize handler, the handler is called when the tty size changes.
      Specified by:
        `resizehandler` in interface `Tty`
      Parameters:
        `handler` - the resize handler
      Returns:
        this object

    - #### end

          void end()

      End the process with the exit status 0

    - #### end

          void end​(int status)

      End the process.
      Parameters:
        `status` - the exit status.